<?php

/**
 * @package 2Moons
 * @author Jorge Navarrete (Jekill) <spacewarinfo@gmail.com>
 * @licence MIT
 * @version 2.0
 * @link https://github.com/ImJekill
 */
class Module
{

	static public function get()
	{
		$db     = Database::get();
		$modResult = $db->nativeQuery("SELECT * FROM %%MODULES%%;");

		$modules = [];

		foreach ($modResult as $modRow)
		{
			$modules[] = $modRow;
		}

		return $modules;
	}

	static function save_mod($mod_id, $mod_status){
		$sql = 'UPDATE %%MODULES%% SET `mod_status`=:mod_status WHERE `id` = :id';
		$params[':id'] = $mod_id;
		$params[':mod_status'] = $mod_status;
		$db     = Database::get();
		$db->update($sql, $params);
	}

	static function insert_mod($mod_data){

		$insertData = [];
		$params = [];

		foreach ($mod_data as $key => $value) {
			$insertData[] = '`'.$key.'`=:'.$key;
			$params[':' . $key] = $value;
		}

		$sql = 'INSERT INTO %%MODULES%% SET '.implode(', ', $insertData);

		$db     = Database::get();
		$db->insert($sql, $params);
	}

	static function delete_mod($mod_tag){
		$sql	= 'DELETE FROM %%MODULES%% WHERE mod_tag = :mod_tag;';
		$params[':mod_tag'] = $mod_tag;

		$db     = Database::get();
		$db->delete($sql, $params);
	}
}
