<?php

/**
 *  2Moons 
 *   by Jan-Otto Kröpke 2009-2016
 *
 * For the full copyright and license information, please view the LICENSE
 *
 * @package 2Moons
 * @author Jan-Otto Kröpke <slaver7@gmail.com>
 * @copyright 2009 Lucky
 * @copyright 2016 Jan-Otto Kröpke <slaver7@gmail.com>
 * @licence MIT
 * @version 1.8.0
 * @link https://github.com/jkroepke/2Moons
 */

if (!allowedTo(str_replace(array(dirname(__FILE__), '\\', '/', '.php'), '', __FILE__))) throw new Exception("Permission error!");

function ShowModulePage()
{
	global $LNG;

	$config	= Config::get(Universe::getEmulated());
	$module	= explode(';', $config->moduls);
	
	if($_GET['mode']) {
		$module[HTTP::_GP('id', 0)]	= ($_GET['mode'] == 'aktiv') ? 1 : 0;
		$config->moduls = implode(";", $module);
		$config->save();
		ClearCache();
	}
	
	$IDs	= range(0, MODULE_AMOUNT - 1);
	foreach($IDs as $ID => $Name) {
		$Modules[$ID]	= array(
			'name'	=> $LNG['modul_'.$ID],
			'state'	=> isset($module[$ID]) ? $module[$ID] : 1,
		);
	}
	
	asort($Modules);


	$mod_ = new Module;

	if($_GET['action']){
		$mod 	= HTTP::_GP('id', 0);
		$status = ($_GET['action']=='on') ? 1 : 0;
		$mod_->save_mod($mod, $status);
		ClearCache();
	}

	if($_POST){
		if($_POST['directive'] == 'install')
			install_mod();
		
	}	

	if($_GET['directive']){
		if($_GET['directive'] == 'uninstall')
			uninstall_mod($_GET['mod']);
	}

	$template_mods = Module::get();

	$template	= new template();

	$template->assign_vars(array(
		'Modules'				=> $Modules,
		'mod_module'			=> $LNG['mod_module'],
		'mod_info'				=> $LNG['mod_info'],
		'mod_active'			=> $LNG['mod_active'],
		'mod_deactive'			=> $LNG['mod_deactive'],
		'mod_change_active'		=> $LNG['mod_change_active'],
		'mod_change_deactive'	=> $LNG['mod_change_deactive'],
		'mod_installed'			=> $template_mods,
		'mod_delete'			=> $LNG['button_delete']
	));
	
	$template->show('ModulePage.tpl');
}

function install_mod(){
	$mod_file = $_FILES['mod_pack'];

	$p_name = $mod_file['name'];

	if(move_uploaded_file($mod_file['tmp_name'], CACHE_PATH.'/plugin_to_install.zip')) {
		$zip = new ZipArchive;
		if ($zip->open(CACHE_PATH.'plugin_to_install.zip') === TRUE) {
			$zip->extractTo(CACHE_PATH, array('installation.xml'));

			$installation = simplexml_load_file(CACHE_PATH.'installation.xml');

			$rute = MODULES_PATH.$installation->mod_data->plugin_tag;

			if(!file_exists($rute)){
				mkdir($rute, 0777, true);
			}

			$zip->extractTo($rute);

			if(isset($installation->administration)){
				foreach($installation->administration->admin_controller as $key => $value){
					$value = trim($value);
					$controllers_name = trim($value);

					if(!file_exists(ROOT_PATH.'includes/pages/adm/'.$value)){
						$zip->extractTo(ROOT_PATH.'includes/pages/adm', array($value));
					}else{
						die('El archivo '.ROOT_PATH.'includes/pages/adm/'.$value.' ya existe.');
					}

					unlink($rute.'/'.$value);
				}
			}

			if(isset($installation->game)){
				foreach($installation->game->game_page as $key => $value){
					$value = trim($value);
					$controllers_name = trim($value);

					if(!file_exists(ROOT_PATH.'includes/pages/game/'.$value)){
						$zip->extractTo(ROOT_PATH.'includes/pages/game', array($value));
					}else{
						die('El archivo '.ROOT_PATH.'includes/pages/game/'.$value.' ya existe.');
					}

					unlink($rute.'/'.$value);
				}
			}
			
			if(isset($installation->administration_view)){
				foreach($installation->administration_view->item as $key => $value){
					$value = trim($value);
					$template_name = trim($installation->administration_view['name']);

					if(!file_exists(ROOT_PATH.'styles/templates/adm/'.$template_name)){
						mkdir(ROOT_PATH.'styles/templates/adm/'.$template_name, 0777, true);
						if(!file_exists(ROOT_PATH.'styles/templates/adm/'.$template_name.'/'.$value)){
							$zip->extractTo(ROOT_PATH.'styles/templates/adm/'.$template_name, array($value));
						}
						
					}else{
						if(!file_exists(ROOT_PATH.'styles/templates/adm/'.$template_name.'/'.$value)){
							$zip->extractTo(ROOT_PATH.'styles/templates/adm/'.$template_name, array($value));
						}else{
							die('El archivo '.ROOT_PATH.'styles/templates/adm/'.$template_name.'/'.$value.' ya existe.');
						}
					}
					unlink($rute.'/'.$value);
				}
			}
			
			if(isset($installation->game_view)){
				foreach($installation->game_view->item as $key => $value){
					$value = trim($value);
					$template_name = trim($installation->game_view['name']);

					if(!file_exists(ROOT_PATH.'styles/templates/game/'.$template_name)){
						mkdir(ROOT_PATH.'styles/templates/game/'.$template_name, 0777, true);
						if(!file_exists(ROOT_PATH.'styles/templates/game/'.$template_name.'/'.$value)){
							$zip->extractTo(ROOT_PATH.'styles/templates/game/'.$template_name, array($value));
						}
						
					}else{
						if(!file_exists(ROOT_PATH.'styles/templates/game/'.$template_name.'/'.$value)){
							$zip->extractTo(ROOT_PATH.'styles/templates/game/'.$template_name, array($value));
						}else{
							die('El archivo '.ROOT_PATH.'styles/templates/game/'.$template_name.'/'.$value.' ya existe.');
						}
					}
					unlink($rute.'/'.$value);
				}
			}

			if(isset($installation->installation_data)){
				$installation_array = (array)$installation;

				foreach ($installation_array['installation_data'] as $node) {
					$rute 		= ROOT_PATH.$node['name'];

					$handle 	= fopen($rute, "r");
					$new_file 	= fread($handle, filesize($rute));

					fclose($handle);

					$comment = generate_comments($rute);

					$new_file = str_replace(trim($node->before), $comment['start']."START ".$installation_array['mod_tag'].$comment['end'].$node->addcode . $comment['start']. "END ".$installation_array['mod_tag'].$comment['end']. $node->before, $new_file);

					@file_put_contents($rute, $new_file);
				}
			}

			if(isset($installation->sql_install)){
				$db 				= Database::get();
				$value 			= trim($installation->sql_install['name']);					
				$zip->extractTo(CACHE_PATH, array($value));
				$installSQL = file_get_contents(CACHE_PATH.$value);
				$db->query(str_replace('%PREFIX%', DB_PREFIX, $installSQL));
				unlink(CACHE_PATH.$value);
			}

			if(isset($installation->sql_uninstall)){
				$value = trim($installation->sql_uninstall['name']);	
				$zip->extractTo(MODULES_PATH.$installation->mod_data->plugin_tag, array($value));
			}

			$zip->close();

			unlink(CACHE_PATH.'plugin_to_install.zip');
			unlink(CACHE_PATH.'installation.xml');

			$data = array();
			$data['mod_tag'] = $installation->mod_data->plugin_tag;
			$data['mod_name'] = $installation->mod_data->plugin_name;
			$data['mod_description'] = $installation->mod_data->plugin_description;
			$data['mod_marketplace'] = $installation->mod_data->plugin_link;
			$data['mod_author'] = $installation->mod_data->developer;
			$data['mod_version'] = $installation->mod_data->version;

			Module::insert_mod($data);

		}else{
			die('No pudo abrirse el archivo');
		}
	}else{
		die('No pudo subirse al servidor');
	}
}

function uninstall_mod($mod_tag){
	if(is_dir(MODULES_PATH.$mod_tag)){
		if(file_exists(MODULES_PATH.$mod_tag.'/installation.xml')){
			$installation = simplexml_load_file(MODULES_PATH.$mod_tag.'/installation.xml');


			if(isset($installation->administration)){
				foreach($installation->administration->admin_controller as $key => $value){
					$value = trim($value);

					if(file_exists(ROOT_PATH.'includes/pages/adm/'.$value)){
						unlink(ROOT_PATH.'includes/pages/adm/'.$value);
					}
				}
			}

			if(isset($installation->game)){
				foreach($installation->game->game_page as $key => $value){
					$value = trim($value);

					if(file_exists(ROOT_PATH.'includes/pages/game/'.$value)){
						unlink(ROOT_PATH.'includes/pages/game/'.$value);
					}
				}
			}
			
			if(isset($installation->administration_view)){
				foreach($installation->administration_view->item as $key => $value){

					$template_name = trim($installation->administration_view['name']);

					delete_folder(ROOT_PATH.'styles/templates/adm/'.$template_name);
				}
			}
			
			if(isset($installation->game_view)){
				foreach($installation->game_view->item as $key => $value){

					$template_name = trim($installation->game_view['name']);

					delete_folder(ROOT_PATH.'styles/templates/game/'.$template_name);
				}
			}

			if(isset($installation->installation_data)){
				$installation_array = (array)$installation;

				foreach ($installation_array['installation_data'] as $node) {
					$rute 		= ROOT_PATH.$node['name'];

					$handle 	= fopen($rute, "r");
					$new_file 	= fread($handle, filesize($rute));

					fclose($handle);

					$comment = generate_comments($rute);


					$first_part = explode($comment['start']."START ".$installation_array['mod_tag'].$comment['end'], $new_file);

					$second_part = explode($comment['start']."END ".$installation_array['mod_tag'].$comment['end'], $first_part[1]);

					$new_file = $first_part[0] . $second_part[1];

					@file_put_contents($rute, $new_file);
				}
			}

			if(isset($installation->sql_uninstall)){
				$db 				= Database::get();
				$value 				= trim($installation->sql_uninstall['name']);	
				$uninstallSQL = file_get_contents(MODULES_PATH.$mod_tag.'/'.$value);
				$db->query(str_replace('%PREFIX%', DB_PREFIX, $uninstallSQL));
			}

		}else{
			die('El archivo de instalacion fue removido.');
		}
		delete_folder(MODULES_PATH.$mod_tag);
		Module::delete_mod($mod_tag);

	}else{
		die('El modulo requerido no existe');
	}
}


function generate_comments($rute){
	$file_type = substr($rute, -3);

	$start_comment 	= '';
	$end_comment 	= '';

	switch ($file_type) {
		case 'php':
			$start_comment 	= "###";
			$end_comment 	= "###\n\r";
			break;
		case 'tpl':
			$start_comment 	= "<!--";
			$end_comment 	= "-->\n\r";
			break;
		case 'css':
		case 'js':
			$start_comment 	= "/***";
			$end_comment 	= "***/\n\r";
			break;
	}

	return array(
		'start' => $start_comment,
		'end'	=> $end_comment
	);
}

function delete_folder($dir) { 
   	$files = array_diff(scandir($dir), array('.','..')); 
    foreach ($files as $file) { 
      (is_dir("$dir/$file")) ? delete_folder("$dir/$file") : unlink("$dir/$file"); 
    } 
    return rmdir($dir); 
} 